' This program designed to be compiled with QB4.0 or QB4.5
' Call this Vx.Rx.Mx with a release date of 6/xx/00
'
'***** WARNING WARNING  start and compile with the /ah option  WARNING *****
'
'   This program does the autoguiding with a Connetix B&W QCam and also does
'saves of darkfield and captured images.  There is no name yet nor can the
'images be used by this program
'Control of camera and drive this version: 6 bit or 4 bit reads.
'Machine independent timer, clock ticks 18.2 at times per second.
'Original program apparently by Don Davies but I didn't get his name in here.
'Program by Marty Niemi and modified for full QB subroutines by Bob May along
'with a bunch of other things. Image write is to 8 bit grayscale Targa format
'This version does the 6 bit image capture as an option.

DECLARE SUB autozero ()       'Adjust Zero to get approx 1 count
DECLARE SUB Calibrate ()      'Calibrate the backlash of the motor drive system
DECLARE SUB checkey ()
DECLARE SUB ClkTicks ()       'do the timing loop with the 18.2/sec. RTC
DECLARE SUB DCommand ()       'Send a command
DECLARE SUB delay ()
DECLARE SUB DReset ()
DECLARE SUB DSetup ()         'Setup the camera with the variables.
DECLARE SUB GetImage ()       'get an image from the camera
DECLARE SUB GetPort ()        'Get the port #s
DECLARE SUB noiseframe ()     'used with autozero
DECLARE SUB scanfield ()      'Scan the image in and get the star loc.
DECLARE SUB screenboxes ()
DECLARE SUB SerialWrite ()    'write the data to the serial port scope control
DECLARE SUB SetPallete ()     'change the palette between white and red
DECLARE SUB WriteDark ()      'write a raw dark frame
DECLARE SUB WriteFrame ()     'Put the frame to a file TGA header

CLEAR
    'set the integer vals as global
DIM SHARED AMilliSecs AS INTEGER, BackLash AS INTEGER
DIM SHARED BinSw AS INTEGER, BinVal AS INTEGER
DIM SHARED BPPix  AS INTEGER, BPTx AS INTEGER
DIM SHARED Col AS INTEGER, CurrentTick AS INTEGER
DIM SHARED YCalSec AS INTEGER, DecmFact AS INTEGER
DIM SHARED YNeg  AS INTEGER
DIM SHARED Ysw AS INTEGER    '0=rev, 1=norm, 2=off
DIM SHARED YPos AS INTEGER, DkCapF AS INTEGER
DIM SHARED DkF AS INTEGER, DoDkCapF AS INTEGER
DIM SHARED DQCont AS INTEGER, DQexp AS INTEGER
DIM SHARED DQOffset AS INTEGER
DIM SHARED EndCol  AS INTEGER
DIM SHARED EndRow AS INTEGER, EndXp AS INTEGER
DIM SHARED EndYp AS INTEGER, Hi AS INTEGER
DIM SHARED Hi2 AS INTEGER, Hi3 AS INTEGER
DIM SHARED IBPP AS INTEGER, ICamOn AS INTEGER
DIM SHARED IChange AS INTEGER
DIM SHARED Inif AS INTEGER, Intens AS INTEGER
DIM SHARED ioff AS INTEGER, ioff2 AS INTEGER
DIM SHARED ISize AS INTEGER, ITCirF AS INTEGER
DIM SHARED ITrkErrLn AS INTEGER, ITrkErrLoc AS INTEGER
DIM SHARED ITrkLn AS INTEGER, ih AS INTEGER
DIM SHARED ih2 AS INTEGER, ih3 AS INTEGER
DIM SHARED iv AS INTEGER, ivv AS INTEGER
DIM SHARED jj AS INTEGER, KKey AS INTEGER
DIM SHARED LControl AS INTEGER, LCommand AS INTEGER
DIM SHARED LData AS INTEGER, Left AS INTEGER
DIM SHARED Lo AS INTEGER, LocTrackStatus AS INTEGER
DIM SHARED LStatus AS INTEGER, MisFrms  AS INTEGER
DIM SHARED mxmisfrms AS INTEGER, Nchr AS INTEGER
DIM SHARED NT AS INTEGER, NTmax AS INTEGER
DIM SHARED OldLeft AS INTEGER
DIM SHARED OldSetNumV AS INTEGER, OldPixelsPerLine AS INTEGER
DIM SHARED OldTopLine AS INTEGER, PixelsPerLine AS INTEGER
DIM SHARED PSetSw AS INTEGER, QContr AS INTEGER
DIM SHARED QDataC AS INTEGER, QDataP AS INTEGER
DIM SHARED QExp AS INTEGER, QMode AS INTEGER, QExp2 AS INTEGER
DIM SHARED QOffset AS INTEGER, XCalSec AS INTEGER
DIM SHARED XPos AS INTEGER, XNeg AS INTEGER
DIM SHARED RedSw AS INTEGER, Row AS INTEGER
DIM SHARED SavFrm AS INTEGER, SetNumH AS INTEGER
DIM SHARED SetNumV AS INTEGER, SData AS INTEGER
DIM SHARED SetLeft AS INTEGER, SetTopLn AS INTEGER, SixBit AS INTEGER
DIM SHARED StartXp AS INTEGER, StartYp AS INTEGER
DIM SHARED Threshold AS INTEGER, Ticks AS INTEGER
DIM SHARED TopLine AS INTEGER, TrkSw AS INTEGER
DIM SHARED WaitTime AS INTEGER, XGoal AS INTEGER
DIM SHARED YGoal AS INTEGER, Xt AS INTEGER
DIM SHARED Yt AS INTEGER, Xfer AS INTEGER
DIM SHARED AvgIdx AS INTEGER, AvgSw AS INTEGER
DIM SHARED AvgCtr AS INTEGER, AvgPtr AS INTEGER
DIM SHARED AvgTrg AS INTEGER, AvgExp AS INTEGER
DIM SHARED Lx AS INTEGER

DIM SHARED NDelay AS LONG, NPoints AS LONG      'long vars as global
DIM SHARED XSum AS LONG, XSumSq AS LONG

DIM SHARED angle AS SINGLE, DeadBand AS SINGLE  'single vars as global
DIM SHARED Yerror AS SINGLE, YNegMag AS SINGLE
DIM SHARED Dx AS SINGLE, Dy AS SINGLE
DIM SHARED TotDx AS SINGLE, TotDy AS SINGLE
DIM SHARED YPosMag AS SINGLE, Cs AS SINGLE, YErOld AS SINGLE
DIM SHARED YNegCon  AS SINGLE, DeltaX AS SINGLE
DIM SHARED DeltaY AS SINGLE, YPosCon AS SINGLE
DIM SHARED Gamma AS SINGLE, Xerror AS SINGLE
DIM SHARED XPosCon AS SINGLE, XPosMag AS SINGLE
DIM SHARED XNegCon AS SINGLE, XNegMag AS SINGLE
DIM SHARED rec2 AS SINGLE, rec3 AS SINGLE
DIM SHARED Sigma AS SINGLE, Sigmasq  AS SINGLE
DIM SHARED Sn AS SINGLE, timeIt AS SINGLE
DIM SHARED x AS SINGLE, xmean AS SINGLE
DIM SHARED Xp AS SINGLE, Yp AS SINGLE

DIM SHARED Check AS STRING, Null AS STRING  'strings as global
DIM SHARED InFileNam AS STRING

'$DYNAMIC                                   'arrays to global
DIM SHARED Bin(1 TO 245) AS INTEGER         'line holding for binning
DIM SHARED Dark1(1 TO 240, 240) AS INTEGER  'array to hold darkframe
DIM SHARED Img1(1 TO 240, 240) AS INTEGER   'array to hold darkframe
DIM SHARED lookup(0 TO 15) AS INTEGER       'pixel brightness table
DIM SHARED AvgPos(1 TO 14, 1 TO 2) AS SINGLE 'position average table

SCREEN 12
CLS
DReset
SetPallete
            'start setting up the variables
Inif = 0
ICamOn = 0                        'Camon flag permits testing with no camera
DkF = 0: DkCapF = 0               'dark sub. flag, dark image capture flag.

XPos = 1: XNeg = 2           'Set bits for serial port motor control for
YPos = 4: YNeg = 8            'normal direction control
XCalSec = 5: YCalSec = 5       'initial Calibration variables
DeadBand = 2: BackLash = 0

IBPP = 4: BPPix = 4: BPTx = 8     'Camera parameters nibble mode
IChange = 1
ISize = 2
DecmFact = 1                      'get every pixel, average 4 if this is a 2
SixBit = 0
NTmax = 80 / DecmFact / DecmFact
QMode = 0
Threshold = 4
DQCont = 10
QExp = 80: QOffset = 222          'initial values for an exposure, blacklevel
QContr = 173                      'and contrast
PixelsPerLine = 80                'starting with the midsize frame
SetNumV = 80                      '#lines in image. Init val is for med. frame
mxmisfrms = 5                     'Tracking error threshold
XGoal = 174: YGoal = 130          'PIXEL COORDS OF GOAL for tracking. Center of screen
TopLine = YGoal - (SetNumV \ 2)   'where the topline is going to be
SetTopLn = TopLine                'these need to be set later
Left = 134: SetLeft = 73
TrkSw = 0: PSetSw = 1
ITCirF = 1: SavFrm = 0
Null = CHR$(0)
WaitTime = 2                      'RTC Clock ticks for wait
Col = 2: Row = 2                  'setup partial screen clear call params
EndCol = 325: EndRow = 243
AvgIdx = 3: AvgTrg = 3
FOR AvgCtr = 1 TO 14
AvgPos(AvgCtr, 1) = 0              'clear the array for averaging
AvgPos(AvgCtr, 2) = 0
NEXT AvgCtr
AvgCtr = 0

FOR i = 0 TO 15                   'Generate the lookup table for the shades
  lookup(i) = 16 - i              'of gray the way the cam put them out.
NEXT i
lookup(0) = 0

GetPort                           'get the ports from the user
IF ICamOn = 1 THEN autozero
screenboxes
LINE (Col, Row)-(EndCol, EndRow), 0, BF  'clearscreen
              'End of housekeeping
DO
  IF TrkSw = 1 AND MisFrms > mxmisfrms THEN  'See if lock lost
    LOCATE ITrkErrLn + 1, 63: PRINT "No Lock"
    IF SData = 1 THEN PRINT #1, "#:Qw#";    'stop W
    IF SData = 2 THEN PRINT #1, "#:Qe#";    'stop E
    IF SData = 4 THEN PRINT #1, "#:Qs#";    'stop S
    IF SData = 8 THEN PRINT #1, "#:Qn#";    'stop N
    IF Lx <> 1 THEN PRINT #1, Null;         'clear the serial port
    Xerror = 0
    Yerror = 0
    Dx = 0
    Dy = 0
    Nchr = 0
    SOUND 400, 5                            'cloud alert
    ISize = 3                               'go to large frame size
    IChange = 1
  END IF
  scanfield
LOOP WHILE KKey <> 99
END

REM $STATIC
SUB autozero  'ADJUST ZERO TO GET APPROX 1 COUNT GAIN ISN'T CHANGED - SB APPROX 120 FOR BEST SENSITIVITY

LINE (Col, Row)-(EndCol, EndRow), 0, BF  'clearscreen
LOCATE 5, 3: PRINT "Adjusting Zero for best result"
OldQMode = QMode                  'save in case of 6 bit
QMode = 0                         'set 4 bit
OldLeft = Left
Left = 2:
OldPixelsPerLine = SetNumH        'we can get a small region to
SetNumH = 4
OldTopLine = TopLine              'work on
OldSetNumV = SetNumV
TopLine = 10: SetNumV = 6         'black region  of the camera
'SetNumH = PixelsPerLine * 4 \ BPTx \ DecmFact
SetTopLn = TopLine
SetLeft = Left \ 2
DQOffset = 16
ioff2 = 5
IF Inif = 0 THEN
  QOffset = 128
  DQOffset = 64
  noiseframe
  ioff2 = 32
END IF
LOCATE 1, 1
FOR ioff = 1 TO ioff2 STEP 1
  QOffset = QOffset + DQOffset
  IF xmean - 1 > 0 THEN QOffset = QOffset - 2 * DQOffset
  noiseframe    'DOUBLE CALL BECAUSE OF SATURATION EFFECTS....
  noiseframe
  IF xmean > .7 AND xmean < 1.2 THEN EXIT FOR
  DQOffset = DQOffset / 2
  IF DQOffset < 1 THEN DQOffset = 1
NEXT ioff
QOffset = QOffset - 2
LOCATE 18, 2: PRINT USING "##.##"; QExp / 250; : PRINT " Sec."; : PRINT USING "#######"; QOffset;
Left = OldLeft                    'restore old parameters
SetNumH = OldPixelsPerLine
TopLine = OldTopLine
SetNumV = OldSetNumV
SetTopLn = TopLine
SetLeft = Left \ 2 + 6
QMode = OldQMode
LINE (Col, Row)-(EndCol, EndRow), 0, BF  'clearscreen

END SUB

SUB Calibrate   'Calibrate the backlash of the motor drive system
    
LOCATE 7, 45: PRINT "Calibration running";
scanfield     'XPos calibration
StartXp = Xp
StartYp = Yp
Nchr = XCalSec * 30
SData = XPos
SerialWrite
scanfield
EndXp = Xp
EndYp = Yp
DeltaX = EndXp - StartXp
DeltaY = EndYp - StartYp
IF DeltaX > 0 THEN
  Lo = 10
  LINE (Col, Row)-(EndCol, EndRow), 0, BF  'clearscreen
  LOCATE 6, 4: PRINT "Please rotate the camera by 180 deg."
  LOCATE 7, 3: PRINT "and press the F5 Key to continue."
  LOCATE 9, 4: PRINT "The X direction of the error was in"
  LOCATE 10, 3: PRINT "the wrong direction for the program."
  LOCATE 12, 4: PRINT "Calibration needs to be run again!"
  DO WHILE Lo = 10
    checkey
  LOOP
  LINE (Col, Row)-(EndCol, EndRow), 0, BF  'clearscreen
  EXIT SUB
END IF
XPosMag = SQR(DeltaX * DeltaX + DeltaY * DeltaY)
IF XPosMag > 0 THEN
  XPosCon = XCalSec / XPosMag
ELSE
  XPosCon = 0
END IF    'Angle (Theta) is from rotation of the chip relative to x y axes
IF ABS(DeltaX) > 0 THEN
  angle = ATN(DeltaY / DeltaX)
ELSE
  angle = 0
END IF
SData = XNeg
SerialWrite
LOCATE 8, 45: PRINT "X Pos Cal: "; : PRINT USING "##.## "; XPosCon;
LOCATE 12, 45: PRINT "Angle: "; : PRINT USING "###.##"; angle;
scanfield                   'XNeg calibration
StartXp = Xp
StartYp = Yp
Nchr = XCalSec * 30
SData = XNeg
SerialWrite
scanfield
EndXp = Xp
EndYp = Yp
DeltaX = EndXp - StartXp
DeltaY = EndYp - StartYp
XNegMag = SQR(DeltaX * DeltaX + DeltaY * DeltaY)
IF XNegMag > 0 THEN
  XNegCon = XCalSec / XNegMag
ELSE
  XNegCon = 0
END IF
SData = XPos
SerialWrite
LOCATE 9, 45: PRINT "X Neg Cal: "; : PRINT USING "##.## "; XNegCon;

IF Ysw = 2 THEN EXIT SUB  'no dec control
' DO
  scanfield                   'YPos calibration
  StartXp = Xp
  StartYp = Yp
  Nchr = YCalSec * 30
  SData = YPos
  SerialWrite
  scanfield
  EndXp = Xp
  EndYp = Yp
  DeltaX = EndXp - StartXp
  DeltaY = EndYp - StartYp
  YPosMag = SQR(DeltaX * DeltaX + DeltaY * DeltaY)
  IF YPosMag > 0 THEN
    YPosCon = YCalSec / YPosMag
  ELSE
    YPosCon = 0
  END IF
  SData = YNeg
  SerialWrite
  scanfield                   'Check for backlash
'deadband is Yp in size, DeltaY is how far it got driven off. Yp/DeltaY is
'the further distance it needed to be driven.  Yp is also the pixel count
'of the deadband backlash in the DEC distance.
  
  IF Yp - StartYp <> 0 THEN 'otherwise a divide by 0
    Nchr = ((Yp - StartYp) / DeltaY) * (YCalSec * 30)
    BackLash = ABS(Yp)
'    LOCATE 5, 70: PRINT BackLash
    SData = YNeg
    IF Nchr >= 1 THEN 'we have a whole char to send
      SerialWrite
    END IF
  END IF
  scanfield
  EndYp = Yp
  DeltaY = EndYp - StartYp

'end put in a section for backlash on the DEC drive.
  
'  IF DeltaY < 0 THEN
'   YPos = YPos XOR &HC
'    YNeg = YNeg XOR &HC
'    IF YPos = &H8 THEN Ysw = 0 ELSE Ysw = 1  'norm up is &h4
'  END IF
' LOOP WHILE DeltaY < 0
LOCATE 10, 45: PRINT "Y Pos Cal: "; : PRINT USING "##.## "; YPosCon;
'YNeg calibration
scanfield
StartXp = Xp
StartYp = Yp
Nchr = YCalSec * 30
SData = YNeg
SerialWrite
scanfield
EndXp = Xp
EndYp = Yp
DeltaX = EndXp - StartXp
DeltaY = EndYp - StartYp
YNegMag = SQR(DeltaX * DeltaX + DeltaY * DeltaY)
IF YNegMag > 0 THEN
  YNegCon = YCalSec / YNegMag
ELSE
  YNegCon = 0
END IF
SData = YPos
SerialWrite
LOCATE 11, 45: PRINT "Y Neg Cal: "; : PRINT USING "##.## "; YNegCon;
LOCATE 7, 45: PRINT "Calibration Done   ";

END SUB

SUB checkey                       'ROUTINE TO READ THE CURSOR KEYS

Hi = 0      'multiple use variable
DO
SELECT CASE INKEY$
  CASE ""
    Hi = 2
  CASE "6"            'go to 6 bit reads
    QMode = &H2
    BPPix = &H2       'BPPix is really 6 but you need to divide by 3 for xfrs
    LOCATE ITrkErrLn, ITrkErrLoc: PRINT "6"
    SetNumH = PixelsPerLine * BPPix \ BPTx \ DecmFact
    DkCapF = 0
    DkF = 0
  CASE "4"            'go to 4 bit reads
    QMode = &H0
    BPPix = &H4
    LOCATE ITrkErrLn, ITrkErrLoc: PRINT "4"
    SetNumH = PixelsPerLine * BPPix \ BPTx \ DecmFact
    DkCapF = 0
    DkF = 0
  CASE "h", "H"
    LINE (Col, Row)-(EndCol, EndRow), 0, BF'clearscreen
    LOCATE 3, 3: PRINT "This program written by Don Davies,";
    LOCATE 4, 3: PRINT "Marty Niemi and Bob May in succession.";
    LOCATE 6, 3: PRINT "Use the keys as specified below for";
    LOCATE 7, 3: PRINT "controlling the program.  Tracking";
    LOCATE 8, 3: PRINT "will occur when a star is above a";
    LOCATE 9, 3: PRINT "threshold and is the only one above";
    LOCATE 10, 3: PRINT "the threshold.";
    LOCATE 12, 6: PRINT "Program version 1.0.0 1/29/00";
    LOCATE 13, 6: PRINT "Press any key to continue";
    DO WHILE INKEY$ = ""
    LOOP
    LINE (Col, Row)-(EndCol, EndRow), 0, BF'clearscreen
  CASE Null + CHR$(75)    'left arrow
    KKey = 2
    Nchr = 15
    SData = XPos
    SerialWrite
  CASE Null + CHR$(77)    'right arrow
    KKey = 2
    Nchr = 15
    SData = XNeg
    SerialWrite
  CASE Null + CHR$(72)    'up arrow
    KKey = 2
    Nchr = 15
    SData = YPos
    SerialWrite
  CASE Null + CHR$(80)    'down arrow
    KKey = 2
    Nchr = 15
    SData = YNeg
    SerialWrite
  CASE Null + CHR$(59)    'X-goal -1 F1
    XGoal = XGoal - 1
    IChange = 1
    IF XGoal < 40 THEN XGoal = 40
    KKey = 1
  CASE Null + CHR$(60)    'X-goal +1 F2
    XGoal = XGoal + 1
    IChange = 1
    IF XGoal > EndCol - 40 THEN XGoal = EndCol - 40
    KKey = 1
  CASE Null + CHR$(61)    'Y-goal -1 F3
    YGoal = YGoal - 1
    IChange = 1
    IF YGoal < 40 THEN YGoal = 40
    KKey = 1
  CASE Null + CHR$(62)    'Y-goal +1 F4
    YGoal = YGoal + 1
    IChange = 1
    IF YGoal > EndRow - 40 THEN YGoal = EndRow - 40
    KKey = 1
  CASE "z"                'Black level down
    KKey = 1
    QOffset = (QOffset - 2)
    IF QOffset < 1 THEN QOffset = 1
  CASE "Z"                'Black level up
    KKey = 1
    IF QOffset > 245 THEN QOffset = 245
    QOffset = (QOffset + 2)
  CASE "g"                'Gain down
    KKey = 1
    IF QContr < 11 THEN QContr = 11
    QContr = (QContr - DQCont)
  CASE "G"                'Gain up
    KKey = 1
    IF QContr > 254 - DQCont THEN QContr = 254 - DQCont
    QContr = (QContr + DQCont)
  CASE "e"                'Exposure time down
    KKey = 1
    QExp = (QExp - (QExp \ 4))
    IF QExp < 14 THEN QExp = 14
  CASE "E"                'Exposure time up
    KKey = 1
    IF QExp > 8000 THEN QExp = 8000
    QExp = (QExp + (QExp \ 4))
  CASE "x"            'X cal down
    XCalSec = XCalSec - 1
    IF XCalSec <= 1 THEN XCalSec = 1
    LOCATE 2, 70: PRINT XCalSec;
  CASE "X"                'X cal up
    XCalSec = XCalSec + 1
    IF XCalSec >= 9 THEN XCalSec = 9
    LOCATE 2, 70: PRINT XCalSec;
  CASE "y"                'DEC cal down
    YCalSec = YCalSec - 1
    IF YCalSec <= 1 THEN YCalSec = 1
    LOCATE 3, 70: PRINT YCalSec;
  CASE "Y"                'DEC cal up
    YCalSec = YCalSec + 1
    IF YCalSec >= 6 THEN YCalSec = 6
    LOCATE 3, 70: PRINT YCalSec;
  CASE "d"                'Deadband down
    DeadBand = DeadBand - .1
    IF DeadBand <= 0 THEN DeadBand = 0
    LOCATE 4, 70: PRINT USING "##.#"; DeadBand;
  CASE "D"                'Deadband up
    DeadBand = DeadBand + .1
    IF DeadBand >= 6 THEN DeadBand = 6
    LOCATE 4, 70: PRINT USING "##.#"; DeadBand;
  CASE "b"                'Backlash down
    BackLash = BackLash - 1
    IF BackLash <= 0 THEN BackLash = 0
    LOCATE 5, 70: PRINT BackLash;
  CASE "B"                'Backlash up
    BackLash = BackLash + 1
    IF BackLash >= 3 THEN BackLash = 3
    LOCATE 5, 70: PRINT BackLash;
  CASE "w"                'Wait time down
    WaitTime = WaitTime - 1
    IF WaitTime <= 0 THEN WaitTime = 0
    LOCATE 6, 69: PRINT USING "###.##"; WaitTime / 18.2;
  CASE "W"                'Wait time up
    WaitTime = WaitTime + 1
    IF WaitTime >= 182 THEN WaitTime = 182
    LOCATE 6, 69: PRINT USING "###.##"; WaitTime / 18.2;
  CASE "a", "A"           'Autocalibrate Offset
    autozero
  CASE "n", "N"           'Red mode switch
    IF RedSw = 1 THEN RedSw = 0 ELSE RedSw = 1
    SetPallete
  CASE "c", "C"           'Clear Screen
    LINE (Col, Row)-(EndCol, EndRow), 0, BF
  CASE "q", "Q"           'Query (scan) scene
    LOCATE 29, 42: PRINT "                                      ";
    LOCATE 29, 42: INPUT ; "Filename Please"; InFileNam
    LOCATE 29, 42: PRINT "                                      ";
    rec2 = 0
    LOCATE 29, 54
    OPEN InFileNam + ".tga" FOR BINARY AS #3
    PUT #3, , TrkSw
    CLOSE #3
    KILL InFileNam + ".tga" 'delete the old file as it may be another size
    OPEN InFileNam + ".tga" FOR BINARY AS #3  'then open it.
    SavFrm = 1
  CASE "t", "T"           'Track toggle on and off.
    LOCATE ITrkErrLn + 1, 44
    IF TrkSw = 0 THEN
      PRINT "Tracking  On"
      MisFrms = 0
      TrkSw = 1
    ELSE
      PRINT "Tracking Off"
      TrkSw = 0
    END IF
  CASE "k", "K"  'toggle averaging
    LOCATE ITrkErrLn + 2, 63
    IF AvgSw = 0 THEN
      FOR AvgCtr = 1 TO 14
      AvgPos(AvgCtr, 1) = 0
      AvgPos(AvgCtr, 2) = 0
      NEXT AvgCtr
      AvgCtr = 0
      PRINT "Frame Avg ON "
      AvgSw = 1
    ELSE
      PRINT "Frame Avg OFF"
      LOCATE 29, 42: PRINT "                                      ";
      AvgSw = 0
END IF
  CASE "f", "F"           'Frame size switch
    SELECT CASE ISize
      CASE IS = 1
        ISize = 3: IChange = 1
        LOCATE ITrkErrLn + 2, 44: PRINT "Large  Frame  ";
        LINE (Col, Row)-(EndCol, EndRow), 0, BF
      CASE IS = 2
        ISize = 1: IChange = 1
        LOCATE ITrkErrLn + 2, 44: PRINT "Small  Frame   ";
        LINE (Col, Row)-(EndCol, EndRow), 0, BF
      CASE IS = 3
        ISize = 2: IChange = 1
        LOCATE ITrkErrLn + 2, 44: PRINT "Medium  Frame  ";
        LINE (Col, Row)-(EndCol, EndRow), 0, BF
      CASE ELSE
    END SELECT
  CASE "p", "P"            'Display the image or not
    IF PSetSw = 0 THEN PSetSw = 1 ELSE PSetSw = 0
  CASE Null + CHR$(63)    'DEC fact. = 1 F5 not listed nor done
    Lo = 0
  CASE Null + CHR$(64)    'DEC fact. = 2 F6 not listed
  CASE Null + CHR$(66)    'Calibrate  F8
    Calibrate
  CASE Null + CHR$(67)  'Reverse DEC F9
    SELECT CASE Ysw
      CASE IS = 0         'Y reversed turn off
        LOCATE 7, 65: PRINT " "
        LOCATE 11, 65: PRINT " "
        Ysw = 2
        YPos = 0
        YNeg = 0
        LOCATE 7, 69: PRINT "Y Off     ";
      CASE IS = 1         'Y normal turn reversed
        LOCATE 7, 65: PRINT "-"
        LOCATE 11, 65: PRINT "+"
        Ysw = 0
        YPos = 8
        YNeg = 4
        LOCATE 7, 69: PRINT "Y Reversed";
      CASE IS = 2         'Y control off turn normal
        LOCATE 7, 65: PRINT "+"
        LOCATE 11, 65: PRINT "-"
        Ysw = 1
        YPos = 4
        YNeg = 8
        LOCATE 7, 69: PRINT "Y Normal  ";
      CASE ELSE
    END SELECT
  CASE Null + CHR$(68)    'Capture Darkframe F10
'    rec2 = 0   'if you uncomment this, don't forget the part in scanfield!!
'    OPEN "dark.raw" FOR BINARY AS #3
'    PUT #3, , TrkSw
'    CLOSE #3
'    KILL "dark.raw"
'    OPEN "dark.raw" FOR BINARY AS #2 LEN = 1
    DoDkCapF = 1
CASE "j", "J"   ' Darkframe Toggle
    IF DkF = 1 THEN
      DkF = 0
    ELSE
      DkF = 1
      IF DkCapF = 0 THEN
        DkF = 0
      END IF
    END IF
    screenboxes
' CASE "J"
'   IF DkCapF = 1 THEN
'     rec2 = 0
'     OPEN "dark.raw" FOR BINARY AS #3
'     PUT #3, , TrkSw
'     CLOSE #3
'     KILL "dark.raw"
'     OPEN "dark.raw" FOR BINARY AS #2 LEN = 1
'     WriteDark
'     CLOSE #2
'  END IF
  CASE "I"
    AvgTrg = AvgTrg + 1
    IF AvgTrg > 14 THEN AvgTrg = 14
    LOCATE ITrkErrLn + 3, 78: PRINT USING "##"; AvgTrg
  CASE "i"
    AvgTrg = AvgTrg - 1
    IF AvgTrg < 2 THEN AvgTrg = 1
    LOCATE ITrkErrLn + 3, 78: PRINT USING "##"; AvgTrg
  CASE "L"
    Threshold = Threshold + 1
    IF Threshold > 14 THEN Threshold = 14
    LOCATE ITrkErrLn + 3, 60: PRINT USING "##"; Threshold
  CASE "l"
    IF Threshold < 1 THEN Threshold = 1
    Threshold = Threshold - 1
    LOCATE ITrkErrLn + 3, 60: PRINT USING "##"; Threshold
  CASE "M"
    AvgIdx = AvgIdx + 1
    IF AvgIdx > 14 THEN AvgIdx = 14
    LOCATE ITrkErrLn + 2, 78: PRINT USING "##"; AvgIdx
  CASE "m"
    AvgIdx = AvgIdx - 1
    IF AvgIdx < 2 THEN AvgIdx = 2
    LOCATE ITrkErrLn + 2, 78: PRINT USING "##"; AvgIdx
  CASE "o", "O"           'Circles Toggle
    IF ITCirF = 0 THEN
      ITCirF = 1
      LOCATE 15, 70: PRINT "          "
    ELSE
      ITCirF = 0
      LOCATE 15, 70: PRINT "circle off"
    END IF
  CASE "u", "U"           'interface toggle
    IF Lx = 0 THEN
        Lx = 1
        CLOSE #1
            IF QDataC = 1 THEN
                COM$ = "COM1: 9600,N,8,1,CD0,CS0,DS0,RS" 'LX200 port only
                OPEN COM$ FOR RANDOM AS #1
                END IF
            IF QDataC = 2 THEN
                COM$ = "COM2: 9600,N,8,1,CD0,CS0,DS0,RS" 'LX200 port only
                OPEN COM$ FOR RANDOM AS #1
                END IF
    LOCATE 18, 63: PRINT "LX-200 Interface"
    ELSE
        Lx = 0
        CLOSE #1
            IF QDataC = 1 THEN
                COM$ = "COM1: 300,N,8,1,BIN,RS,OP0,DS0"   'Activate the port for output
                OPEN COM$ FOR RANDOM AS #1
                END IF
            IF QDataC = 2 THEN
                COM$ = "COM2: 300,N,8,1,BIN,RS,OP0,DS0"
                OPEN COM$ FOR RANDOM AS #1
                END IF
        LOCATE 18, 63: PRINT "UART Interface  "
    END IF

  CASE "v", "V"           'Bin Toggle
    IF BinSw = 0 THEN BinSw = 1 ELSE BinSw = 0
  CASE CHR$(27)           'Exit the program
    OPEN "camcfg.dat" FOR RANDOM AS #4 LEN = 4
    PUT #4, 1, QDataC
    PUT #4, 2, QDataP
    PUT #4, 3, QExp
    PUT #4, 4, QOffset
    PUT #4, 5, QContr
    PUT #4, 6, YCalSec
    PUT #4, 7, XCalSec
    PUT #4, 8, DeadBand
    PUT #4, 9, BackLash
    PUT #4, 10, WaitTime
    PUT #4, 11, Threshold
    PUT #4, 12, Ysw
    PUT #4, 13, XPosCon
    PUT #4, 14, XNegCon
    PUT #4, 15, YPosCon
    PUT #4, 16, YNegCon
    PUT #4, 17, AvgSw
    PUT #4, 18, AvgIdx
    PUT #4, 19, AvgTrg
    PUT #4, 20, Lx
 CLOSE #4
    END
  CASE ELSE               'other keys
END SELECT
LOOP UNTIL Hi = 2
' Used Symbols in CAPS 46ABCDEFGhIJkLmNOPQRsTuVWXyZ|ARROWS|Esc| |
  IF KKey = 1 THEN
    LOCATE 18, 2: PRINT USING "##.##"; QExp / 250; : PRINT " Sec.";
    PRINT USING "#######"; QOffset; QContr;
    PRINT USING "####.##"; Dx; Dy;
    LINE (Col, Row)-(EndCol, EndRow), 0, BF'clearscreen
  END IF
  IF KKey = 2 THEN
    DEF SEG = 0             'Empty the keyboard buffer for the cursor keys
    Byte = PEEK(&H41A)
    POKE (&H41C), Byte
  END IF

  KKey = 0
  SetNumH = PixelsPerLine * BPPix \ BPTx \ DecmFact
  SetTopLn = TopLine
  SetLeft = Left \ 2 + 6

END SUB

SUB ClkTicks     'do the timing loop with the 18.2/sec. RTC
    
DEF SEG = 0
DO UNTIL Ticks < 1
  CurrentTick = PEEK(&H46C)
  DO WHILE CurrentTick = PEEK(&H46C)
  LOOP
  Ticks = Ticks - 1
LOOP
DEF SEG     'get back the default segment

END SUB

SUB DCommand                      'Sends a byte out the parallel port

IF ICamOn <> 1 THEN         'no camera
  EXIT SUB
END IF
OUT LData, LCommand
AMilliSecs = 5
delay                       'delay for 5 counts
OUT LControl, &H6
DO WHILE (&H8 AND INP(LStatus)) = 0     'get the Hi nibble
LOOP
Hi = &HF0 AND INP(LStatus)  'and status reg with F0 for the 4 bits
OUT LControl, &HE           'toggle the ack bit back again
delay
DO WHILE (&H8 AND INP(LStatus)) <> 0    'now go for the Lo nibble
LOOP
Lo = &HF0 AND INP(LStatus)   'and status reg with F0 for the 4 bits

END SUB

SUB delay     'delay for a bit

NDelay = 2 * AMilliSecs
FOR IDELAY = 1 TO NDelay
NEXT IDELAY

END SUB

SUB DReset              'Reset the camera
    
AMilliSecs = 10
OUT LControl, &H0        'set reset bit low xxxx x0xx
delay
OUT LControl, &HE

END SUB

SUB DSetup                    'Setup the camera with the variables.

DReset
LCommand = &H11: DCommand     'vertical size
LCommand = SetNumV: DCommand
LCommand = &H13: DCommand
LCommand = SetNumH: DCommand
LCommand = &HD: DCommand      'first line to send
LCommand = SetTopLn: DCommand
LCommand = &HF: DCommand      'first pixel to send
LCommand = SetLeft: DCommand
LCommand = &H19: DCommand     'contrast
LCommand = QContr: DCommand
LCommand = &H1F: DCommand     'black level.
LCommand = QOffset: DCommand
LCommand = &HB: DCommand      'exposure
QExp2 = 255
LCommand = QExp2: DCommand

END SUB

SUB GetPort           'Get the port address from the bios point in menory

OPEN "camcfg.dat" FOR RANDOM AS #4 LEN = 4
GET #4, , QDataC
IF EOF(4) = 0 THEN
    LOCATE 5, 3: PRINT "Getting last setup from disk."
    GET #4, 1, QDataC
    GET #4, 2, QDataP
    GET #4, 3, QExp
    GET #4, 4, QOffset
    GET #4, 5, QContr
    GET #4, 6, YCalSec
    GET #4, 7, XCalSec
    GET #4, 8, DeadBand
    GET #4, 9, BackLash
    GET #4, 10, WaitTime
    GET #4, 11, Threshold
    GET #4, 12, Ysw
    GET #4, 13, XPosCon
    GET #4, 14, XNegCon
    GET #4, 15, YPosCon
    GET #4, 16, YNegCon
    GET #4, 17, AvgSw
    GET #4, 18, AvgIdx
    GET #4, 19, AvgTrg
    GET #4, 20, Lx

    IF QDataC = 1 THEN
      IF Lx = 1 THEN
        COM$ = "COM1: 9600,N,8,1,CD0,CS0,DS0,RS" 'LX200 port only
        ELSE
        COM$ = "COM1: 300,N,8,1,BIN,RS,OP0,DS0"   'Activate the port for output
      END IF
        OPEN COM$ FOR RANDOM AS #1
    END IF
    IF QDataC = 2 THEN
      IF Lx = 1 THEN
        COM$ = "COM2: 9600,N,8,1,CD0,CS0,DS0,RS" 'LX200 port only
        ELSE
        COM$ = "COM2: 300,N,8,1,BIN,RS,OP0,DS0"
      END IF
        OPEN COM$ FOR RANDOM AS #1
    END IF
    DEF SEG = &H40                    'Get the address of the LPT1 port
    IF QDataP = 1 THEN
      LData = PEEK(&H8) + (PEEK(&H9) * &H100)
    ELSE
      LData = PEEK(&HA) + (PEEK(&HB) * &H100)
    END IF
    DEF SEG
ELSE
  QDataC = 0             'make sure the do loop works
  DO                                'Get the serial port number
    LOCATE 13, 19: PRINT "The only valid Serial Port numbers are 1 or 2"
    LData = 1
    LOCATE 11, 11: INPUT "Which Serial Port do you want to use for the autoguider? ", QDataC
    IF QDataC = 1 THEN
      COM$ = "COM1: 300,N,8,1,BIN,RS,OP0,DS0"
      OPEN COM$ FOR RANDOM AS #1
    END IF
    IF QDataC = 2 THEN
      COM$ = "COM2: 300,N,8,1,BIN,RS,OP0,DS0"
      OPEN COM$ FOR RANDOM AS #1
    END IF
    IF (QDataC <> 1) AND (QDataC <> 2) THEN
      LOCATE 19, 33: PRINT "Not a valid port address at that location!"
      SOUND 1800, 4
    END IF
  LOOP WHILE QDataC <> 1 AND QDataC <> 2
  PRINT #1, Null;                        'Clear serial port
  LOCATE 19, 33: PRINT "                                           "
  QDataP = 0             'make sure the do loop works
  DO
    LOCATE 13, 19: PRINT "The only valid Parallel Port numbers are 1 or 2"
    LOCATE 11, 11: INPUT "Which Parallel Port do you want to use for the autoguider? ", QDataP
    DEF SEG = &H40
    IF QDataP = 1 THEN
      LData = PEEK(&H8) + (PEEK(&H9) * &H100)
    ELSE
      LData = PEEK(&HA) + (PEEK(&HB) * &H100)
    END IF
    IF (QDataP <> 1) AND (QDataP <> 2) THEN
      LOCATE 19, 33: PRINT "Not a valid port address at that location!"
      SOUND 1800, 4
    END IF
    DEF SEG
  LOOP WHILE (QDataP <> 1) AND (QDataP <> 2)
  LOCATE 13, 19: PRINT "                                               "
  LOCATE 11, 11: PRINT "                                                                "
  LOCATE 19, 33: PRINT "                                           "
END IF
CLOSE #4
LStatus = LData + 1: LControl = LData + 2
timeIt = TIMER + 2      'get the time and increment by 2 seconds for checking

LCommand = &HD
OUT LData, LCommand
OUT LControl, &H6
DO WHILE (&H8 AND INP(LStatus)) = 0      'get the Hi nibble
IF TIMER > timeIt THEN
  CamOn = 0
  EXIT SUB
END IF
LOOP
Hi = (INP(LStatus) AND &HF0)
OUT LControl, &HE
DO WHILE (&H8 AND INP(LStatus)) <> 0     'get the Lo nibble
IF TIMER > timeIt THEN
  CamOn = 0
  EXIT SUB
END IF
LOOP
    SELECT CASE Ysw
      CASE IS = 0         'Y reversed
        YPos = 0: YPos = YPos XOR 8
        YNeg = 0: YNeg = YNeg XOR 4
'        LOCATE 26, 44: PRINT "Y Toggle Reversed";
      CASE IS = 1         'Y normal
        YPos = 0: YPos = YPos XOR 4
        YNeg = 0: YNeg = YNeg XOR 8
'        LOCATE 26, 44: PRINT "Y Toggle Normal  ";
      CASE IS = 2         'Y control off
        YPos = 0: YNeg = 0       'turn off the Y control.
'        LOCATE 26, 44: PRINT "Y Toggle Off     ";
      CASE ELSE
    END SELECT
Lo = Hi + ((INP(LStatus) AND &HF0) \ 16)
LCommand = &H17: DCommand
OUT LControl, &H6
DO WHILE (&H8 AND INP(LStatus)) = 0
LOOP
Hi = (INP(LStatus) AND &HF0)
OUT LControl, &HE
DO WHILE (&H8 AND INP(LStatus)) <> 0
LOOP
Lo = Hi + ((INP(LStatus) AND &HF0) \ 16)
OUT LControl, &H6
DO WHILE (&H8 AND INP(LStatus)) = 0
LOOP
Hi = (INP(LStatus) AND &HF0)
OUT LControl, &HE
DO WHILE (&H8 AND INP(LStatus)) <> 0
LOOP
Hi = Hi + ((INP(LStatus) AND &HF0) \ 16)

END SUB

SUB noiseframe                'Calculate the noise on a small centered frame
      'Called only by the AUTOZERO subroutine.

DSetup
LOCATE 17, 12: PRINT "e";
Ticks = QExp \ 14             'delay for exposure time so you get the
ClkTicks                      'correct image and past 255 do bulb exp.
LOCATE 17, 12: PRINT "d";
LCommand = &H7: DCommand      'Send Video Frame Command
LCommand = QMode: DCommand
XSum = 0: XSumSq = 0: NPoints = 0   'setup the variables
FOR iv = 1 TO SetNumV STEP DecmFact
  FOR ih = 1 TO SetNumH STEP DecmFact 'PixelsPerLine \ 2 STEP DecmFact
    OUT LControl, &H6
    DO WHILE (&H8 AND INP(LStatus)) = 0
    LOOP
    Hi = lookup((INP(LStatus) AND &HF0) \ 16)
    OUT LControl, &HE
    DO WHILE (&H8 AND INP(LStatus)) <> 0
    LOOP
    Lo = lookup((INP(LStatus) AND &HF0) \ 16)
    IF iv > 1 THEN                'the first line is often bad
      IF ih > 1 THEN
        XSum = XSum + Lo + Hi     'sum all of the vals together
        XSumSq = XSumSq + Lo * Lo + Hi * Hi   'and the squares
        NPoints = NPoints + 2     'inc. the #points counter
      END IF
    END IF
  NEXT ih
NEXT iv
OUT LControl, &H6                 'send end of frame indication
AMilliSecs = 5
delay
OUT LControl, &HE
xmean = CSNG(XSum) / NPoints
Sigma = SQR((CSNG(XSumSq) / NPoints) - xmean * xmean)

END SUB

SUB scanfield                 'scan in the image into the display

IF IChange <> 0 THEN          'else change the size to the next size
  LINE (Col, Row)-(EndCol, EndRow), 0, BF  'clearscreen
  IF ISize = 3 THEN           'define large area - full image
    PixelsPerLine = 320       'number of pixels in a line
    Left = 2                  'left edge on image array first 12 are blk.
    SetNumV = 240             'num lines
    TopLine = 2               'top line of image array
  ELSEIF ISize = 2 THEN       'medium sized image - 80x80 pixels
    PixelsPerLine = 80
    Left = XGoal - (PixelsPerLine \ 2)
    SetNumV = 80
    TopLine = YGoal - (SetNumV \ 2)
  ELSEIF ISize = 1 THEN       'small sized image 36x36 pixel image
    PixelsPerLine = 36
    Left = XGoal - (PixelsPerLine \ 2)
    SetNumV = 36
    TopLine = YGoal - (SetNumV \ 2)
  END IF
  SetNumH = PixelsPerLine * BPPix \ BPTx \ DecmFact
  SetLeft = Left \ 2 + 6
  SetTopLn = TopLine
  IChange = 0
END IF
IF DoDkCapF = 1 THEN          'get a full frame dark
    PixelsPerLine = 320       'number of pixels in a line
    Left = 2                  'left edge on image array first 12 are blk.
    SetNumV = 240             'num lines
    TopLine = 2               'top line of image array
    SetNumH = PixelsPerLine * BPPix \ BPTx \ DecmFact
    SetLeft = Left \ 2 + 6
    SetTopLn = TopLine
    IChange = 1               'set flag so we return to the set size
END IF

Xfer = (PixelsPerLine * BPPix) \ BPTx   'StartRead  get an image
IF BPPix = 2 THEN Xfer = Xfer * 3
IF KKey = 0 THEN              'Skip delay if update because of keystroke
  Ticks = WaitTime
  ClkTicks
END IF
Xp = 0: Yp = 0: Xt = 0: Yt = 0: NT = 0  'reset the star finder vars
DSetup                        'setup the camera paramaters
LOCATE 17, 12: PRINT "E"
Ticks = QExp \ 14             'delay for exposure time so you get the
ClkTicks                      'correct image and past 255 do bulb exp.
LCommand = &H7: DCommand
LCommand = QMode: DCommand
LOCATE 17, 12: PRINT "D"
IF ICamOn = 1 THEN         'camera  ****temp
FOR iv = 1 TO SetNumV STEP DecmFact 'reads a set of lines
  FOR ih = 1 TO Xfer STEP DecmFact  'Read a line, 2 nibble/loop
    OUT LControl, &H6
    DO WHILE (&H8 AND INP(LStatus)) = 0   'get the Hi nibble
    LOOP
    Hi = (INP(LStatus) AND &HF0)
    OUT LControl, &HE
    DO WHILE (&H8 AND INP(LStatus)) <> 0  'get the Lo nibble
    LOOP
    Lo = (INP(LStatus) AND &HF0) \ 16
    Img1(iv, ih) = Hi + Lo    'pixels for 4 bit, parts for 6 bit pixels
  NEXT ih
NEXT iv
END IF                     'camera  ****temp
IF DoDkCapF = 1 THEN          'move the data to the darkframe buffer
  FOR iv = 1 TO SetNumV STEP DecmFact
    FOR ih = 1 TO Xfer STEP DecmFact
      
      Dark1(iv, ih) = Img1(iv, ih)
    NEXT ih
  NEXT iv
END IF
LOCATE 17, 12: PRINT " "
FOR iv = 1 TO SetNumV STEP DecmFact   'take the data from the input buf
  ivv = iv + TopLine        '6 bit pixels are a 3 byte read for 4 pixels.
  FOR ih = 1 TO PixelsPerLine \ 2 STEP DecmFact
    ih2 = ih + ih + Left
    IF iv = 47 THEN             'camera  ****temp to make a spot
      IF ih = 22 THEN
        Img1(iv, ih) = &HF0   'camera  ****temp 20,20 centered
      END IF
    END IF                      'camera  ****temp
   
    IF BPPix <> 2 THEN      'either 4 or 6 bit/pixel to Hi,Lo vals
      Hi = lookup((Img1(iv, ih) AND &H10) \ 16)
          IF Hi > 8 THEN
            LOCATE 21, 3: PRINT "Image point V,H at "; iv; ih
          END IF
      Lo = lookup(Img1(iv, ih) AND &HF)
          IF Lo = 1 THEN
            LOCATE 21, 3: PRINT "Image point V,H at "; iv; ih
          END IF
    ELSE
      ih3 = ih + (ih \ 2)
      IF ih MOD 2 = 1 THEN
        Hi = &H3F - (Img1(iv, ih3) \ 4)
        Lo = &H3F - (((Img1(iv, ih3) AND &H3) * 16) OR (Img1(iv, ih3 + 1) \ 16))
            'low 2 bits first byte and 4 upper bits of 2nd byte
      ELSE  'lower 4 bits of 2nd byte and upper 2 bits of byte 3
        Hi = &H3F - ((Img1(iv, ih3 - 1) AND &HF) * 4) OR (Img1(iv, ih3) \ 64)
        Lo = &H3F - (Img1(iv, ih3) AND &H3F)
      END IF
    END IF
    IF DkF = 1 THEN               'If flag is set, do dark frame subtraction
      IF BPPix <> 2 THEN          '4 bit
        Hi = Hi - lookup((Dark1(iv, ih) AND &HF0) \ 16)
        Lo = Lo - lookup((Dark1(iv, ih) AND &HF))
      ELSE                        '6 bit pixels
        ih3 = ih + (ih \ 2)
        IF ih MOD 2 = 1 THEN
          Hi = Hi - (&H3F - (Dark1(iv, ih3) \ 4))
          IF Hi > 8 THEN
            LOCATE 22, 3: PRINT "Dark point V,H at "; iv; ih
          END IF
          Lo = Lo - (&H3F - (((Dark1(iv, ih3) AND &H3) * 16) OR (Dark1(iv, ih3 + 1) \ 16)))
          IF Hi > 8 THEN
            LOCATE 22, 3: PRINT "Dark point V,H at "; iv; ih
          END IF
        ELSE
          Hi = Hi - (&H3F - ((Dark1(iv, ih3 - 1) AND &HF) * 4) OR (Dark1(iv, ih3) \ 64))
          Lo = Lo - (&H3F - (Dark1(iv, ih3) AND &H3F))
        END IF
      END IF
      IF Hi < 0 THEN Hi = 0       'limit to 0 for lower end
      IF Lo < 0 THEN Lo = 0
    END IF
    IF BPPix = 2 THEN
      Hi = Hi \ 4
      Lo = Lo \ 4
    END IF
    IF PSetSw = 1 THEN
      PSET (ih2, ivv), Hi
      PSET (ih2 + 1, ivv), Lo
    END IF
    IF ISize = 3 AND BinSw = 1 THEN     'do a 4x4 binning in large frame
      IF (iv MOD 2) = 1 THEN            'if it's an even line then put pixel
        LineCtr = LineCtr + 1           'inc. line every 2 iv's
        BinVal = (Lo + Hi) \ 2
        BinVal = (BinVal + Bin(ih)) \ 2
        PSET (ih, LineCtr), ABS(BinVal)
        BinVal = 0
      END IF
      Bin(ih) = (Hi + Lo) \ 2
    END IF
    IF iv = SetNumV \ 2 AND ih = PixelsPerLine \ 4 THEN
      LOCATE 12, 78: PRINT USING "##"; Hi;
    END IF
    IF iv > 1 AND ih > 1 THEN
      IF NT < NTmax THEN
        IF Hi > Threshold THEN
          NT = NT + 1         'up the pixel count above the threshold
          Xt = Xt + ih2       'locate the pixel-lower left is the end
          Yt = Yt + ivv
        END IF
        IF Lo > Threshold THEN  'same for the low pixel of the pair
          NT = NT + 1
          Xt = Xt + ih2 + 1
          Yt = Yt + ivv
        END IF
      END IF
    END IF
  NEXT ih
NEXT iv
LineCtr = 0
OUT LControl, &H6             'send end of frame indication
AMilliSecs = 5
delay
OUT LControl, &HE
IF DoDkCapF = 1 THEN
  DoDkCapF = 0
  DkCapF = 1
  LOCATE ITrkErrLn + 4, 49: PRINT "Saved";
END IF
IF SavFrm = 1 THEN
  WriteFrame
  CLOSE #3
  SavFrm = 0
END IF
LINE (XGoal, YGoal - 3)-(XGoal, YGoal + 3), 15     'draw the cross hair
LINE (XGoal - 3, YGoal)-(XGoal + 3, YGoal), 15

IF NT > 0 AND NT < NTmax THEN
  Xp = Xt / NT                'get the average values of the points
  Yp = Yt / NT                'thus getting the center of the image
  IF ITCirF = 1 THEN          'draw the circle if desired
    IF NT < 10 THEN NT = 10
    IF NT > 50 THEN NT = 50
    CIRCLE (Xp, Yp), NT \ 2, 14
  END IF
  Dx = XGoal - Xp
  Dy = YGoal - Yp
END IF
IF NT >= NTmax THEN     'AUTOMATIC TRACKING COMP..too many points sound warning
'  SOUND 880, 2
  LOCATE ITrkErrLn + 1, 63: PRINT "No Lock"
  Dx = 0
  Dy = 0
END IF

IF TrkSw = 1 THEN      'Move the motors for X and Y delta Skip if track is off
  LOCATE 7, 45: PRINT "                   ";
  LOCATE 8, 45: PRINT "                   ";
  LOCATE 9, 45: PRINT "                   ";
  LOCATE 10, 45: PRINT "                   ";
  LOCATE 11, 45: PRINT "                   ";
  IF NT > 0 AND NT < NTmax THEN
'   SOUND 1800, 2
    LOCATE ITrkErrLn + 1, 63: PRINT "Lock             "
    MisFrms = 0
    IF AvgSw = 1 THEN      'average the values of Dx and Dy
      AvgExp = AvgExp + 1
      AvgCtr = AvgCtr + 1
      AvgPos(AvgCtr, 1) = Dx    'save the values.
      AvgPos(AvgCtr, 2) = Dy
      LOCATE 29, 42: PRINT USING "## ####.## ####.##      "; AvgCtr; AvgPos(AvgCtr, 1); AvgPos(AvgCtr, 2);
      IF AvgCtr >= AvgIdx THEN AvgCtr = 0
    END IF
    LOCATE 18, 26: PRINT USING "####.##"; Dx; Dy;
  ELSE
    MisFrms = MisFrms + 1
    LOCATE ITrkErrLn + 1, 63: PRINT "        "
    LOCATE ITrkErrLn + 1, 78: PRINT USING "##"; MisFrms
    IF MisFrms > mxmisfrms THEN MisFrms = mxmisfrms + 1
  END IF
  IF AvgSw = 1 AND AvgExp >= AvgTrg THEN
    TotDx = 0
    TotDy = 0
    FOR AvgPtr = 1 TO AvgIdx          'total up the values. 14x val of up to 320=4430
      TotDx = TotDx + AvgPos(AvgPtr, 1)
      TotDy = TotDy + AvgPos(AvgPtr, 2)
'      PRINT USING "###.### "; AvgPos(AvgPtr, 1); AvgPos(AvgPtr, 2); AvgPtr; TotDx; TotDy; AvgCtr
    NEXT AvgPtr
    Dx = TotDx / AvgIdx
    Dy = TotDy / AvgIdx
'    PRINT USING "###.### "; TotDx / AvgPtr; TotDy / AvgPtr; AvgPtr
    LOCATE 29, 65: PRINT USING "####.##"; Dx; Dy;
    LOCATE 18, 26: PRINT USING "####.##"; Dx; Dy;
  ELSEIF AvgSw = 1 THEN
    checkey
    EXIT SUB
  END IF
  AvgExp = 0
  Cs = COS(angle)
  Sn = SIN(angle)
  Xerror = Dx * Cs + Dy * Sn
  Yerror = Dy * Cs - Dx * Sn
  IF ABS(Xerror) > DeadBand THEN
    LOCATE 9, 45: PRINT "Correcting"
    LOCATE 10, 46: PRINT "X of "; : PRINT USING "###.##"; Xerror;
    IF Xerror > 0 THEN       'check for polarity
      SData = XNeg          'we're ahead so slow down
      Nchr = (ABS(Xerror * XNegCon) * 30)
    ELSE
      SData = XPos
      Nchr = (ABS(Xerror * XPosCon) * 30)
    END IF
    SerialWrite
  END IF
  IF ABS(Yerror) > DeadBand THEN
    IF Ysw = 2 THEN         'no DEC tracking
      LOCATE 7, 45: PRINT "Ignoring";
      LOCATE 8, 46: PRINT "Y of ";
      PRINT USING "###.##"; Yerror;
    ELSE
      LOCATE 7, 45: PRINT "Correcting"
      IF Yerror > 0 THEN  'positive error
'        IF YErOld < 0 THEN
'          YError = YError + BackLash  'increase by the backlash
'        END IF
        SData = YNeg
        Nchr = (ABS(Yerror * YNegCon) * 30)
      ELSEIF Yerror < 0 THEN
'        IF YErOld > 0 THEN
'          YNeg = YNeg - BackLash
'        END IF
        SData = YPos
        Nchr = (ABS(Yerror * YPosCon) * 30)
      END IF
      YErOld = Yerror
      LOCATE 8, 46: PRINT "Y of ";
      PRINT USING "###.##"; Yerror;
      SerialWrite
    END IF
  END IF
ELSE
  LOCATE 18, 26: PRINT USING "####.##"; Dx; Dy;
END IF
checkey

END SUB

SUB screenboxes

LINE (Col - 1, Row - 1)-(EndCol + 1, EndRow + 1), 15, B 'draw the Image Display Box
LINE (340, 205)-(639, 288), 11, B 'draw the Track Control Box
ITrkErrLn = 14: ITrkErrLoc = 44
ITrkLn = ITrkErrLn
LocTrackStatus = ITrkErrLoc
LOCATE ITrkErrLn, ITrkErrLoc
IF BPPix = 2 THEN
  PRINT "6 Bits Per Pixel image depth"
ELSE
  PRINT "4 Bits Per Pixel image depth"
END IF
LOCATE ITrkErrLn + 1, 44        'tracking on/off select
IF TrkSw = 0 THEN PRINT "Tracking OFF";
IF TrkSw = 1 THEN PRINT "Tracking  ON";
IF ISize = 1 THEN               'print the image capture size
  PixelsPerLine = 36            '1=small, 2=medium, 3=large
  LOCATE ITrkErrLn + 2, 44
  PRINT "Small  Frame";
    ELSEIF ISize = 2 THEN
  PixelsPerLine = 80
  LOCATE ITrkErrLn + 2, 44
  PRINT "Medium Frame";
    ELSEIF ISize = 3 THEN
  PixelsPerLine = 320
  LOCATE ITrkErrLn + 2, 44
  PRINT "Large Frame ";
END IF
LOCATE ITrkErrLn + 3, 63: PRINT "Avg Trigger "
LOCATE ITrkErrLn + 3, 78: PRINT USING "##"; AvgTrg
IF AvgSw = 1 THEN
  LOCATE ITrkErrLn + 2, 63
  PRINT "Frame Avg ON "
END IF
IF AvgSw = 0 THEN
  LOCATE ITrkErrLn + 2, 63
  PRINT "Frame Avg OFF"
END IF
LOCATE ITrkErrLn + 2, 78: PRINT USING "##"; AvgIdx
LOCATE ITrkErrLn + 4, 44
IF DkF = 0 THEN
  PRINT "Dark frame Sub OFF";
ELSE
  IF DkCapF > 0 THEN            'check for a darkframe in memory
    PRINT "Dark frame Sub ON ";
  ELSE
    PRINT "Error: No Dark Frame!   ";
  END IF
END IF
IF Lx = 0 THEN
    LOCATE 18, 63: PRINT "UART Interface  "
        ELSE
        LOCATE 18, 63: PRINT "LX-200 Interface"
        END IF
LOCATE ITrkErrLn + 3, 44
PRINT "Threshold Level "; : PRINT USING "##"; Threshold;
LINE (1, EndRow + 9)-(EndCol + 1, 288), 11, B 'Camera Parameter box
LINE (12, EndRow + 2)-STEP(16, 6), 0, BF      'brightness levels
LINE (30, EndRow + 2)-STEP(16, 6), 1, BF
LINE (48, EndRow + 2)-STEP(16, 6), 2, BF
LINE (66, EndRow + 2)-STEP(16, 6), 3, BF
LINE (84, EndRow + 2)-STEP(16, 6), 4, BF
LINE (102, EndRow + 2)-STEP(16, 6), 5, BF
LINE (120, EndRow + 2)-STEP(16, 6), 6, BF
LINE (138, EndRow + 2)-STEP(16, 6), 7, BF
LINE (156, EndRow + 2)-STEP(16, 6), 8, BF
LINE (174, EndRow + 2)-STEP(16, 6), 9, BF
LINE (192, EndRow + 2)-STEP(16, 6), 10, BF
LINE (210, EndRow + 2)-STEP(16, 6), 11, BF
LINE (228, EndRow + 2)-STEP(16, 6), 12, BF
LINE (246, EndRow + 2)-STEP(16, 6), 13, BF
LINE (264, EndRow + 2)-STEP(16, 6), 14, BF
LINE (282, EndRow + 2)-STEP(16, 6), 15, BF
LOCATE 17, 3
PRINT "Exposure     Zero   Gain  X      Y ";
LOCATE 18, 2: PRINT USING "##.##"; QExp / 250; : PRINT " Sec.";
PRINT USING "#######"; QOffset; QContr;
PRINT USING "####.##"; Dx; Dy;
LINE (340, 0)-(639, 195), 11, B   'Calibration parameter box
LOCATE 2, 45: PRINT "X   Calibration Seconds: "; XCalSec
LOCATE 3, 45: PRINT "Y   Calibration Seconds: "; YCalSec
LOCATE 4, 45: PRINT "Deadband in 1/10 Pixels: ";
PRINT USING "##.#"; DeadBand;
LOCATE 5, 45: PRINT "Backlash Size in Pixels: ";
LOCATE 6, 45: PRINT "Delay added to Exp. Sec:";
LOCATE 6, 69: PRINT USING "###.##"; WaitTime / 18.2;
IF Inif = 0 THEN              'make the X/Y control part only once
  SELECT CASE Ysw
    CASE 0                    'reversed
      LOCATE 7, 65: PRINT "-"
      LOCATE 11, 65: PRINT "+"
      LOCATE 7, 69: PRINT "Y Reversed ";
    CASE 1                    'normal
      LOCATE 7, 65: PRINT "+"
      LOCATE 11, 65: PRINT "-"
      LOCATE 7, 69: PRINT "Y Normal   ";
    CASE 2                    'off
      LOCATE 7, 65: PRINT " "
      LOCATE 11, 65: PRINT " "
      LOCATE 7, 69: PRINT "Y Off      ";
    CASE ELSE
  END SELECT
  LOCATE 7, 66: PRINT CHR$(24)
  LOCATE 8, 66: PRINT CHR$(179);
  LOCATE 9, 66: PRINT CHR$(179); "Y"
  LOCATE 10, 66: PRINT CHR$(179);
  LOCATE 11, 66: PRINT CHR$(25)
  LOCATE 8, 70: PRINT "-"
  LOCATE 9, 70: PRINT CHR$(27); CHR$(196); CHR$(196); CHR$(196); CHR$(196); CHR$(196); CHR$(196); CHR$(45); CHR$(26)
  LOCATE 8, 78: PRINT "+"
  LOCATE 8, 74: PRINT "X"
  LOCATE 12, 59: PRINT "Cursor Pixel Value";
  Inif = 1
END IF

LINE (1, 298)-(639, 468), 11, B 'Control Deys Display Box
LOCATE 20, 5: PRINT "Move the Scope     Move image area"
LOCATE 21, 7: PRINT CHR$(24); " Y Pos             F3   Y-1";
LOCATE 22, 3: PRINT CHR$(27); "X Neg  -  X Pos"; CHR$(26); "   F1 X-1  -  X+1 F2";
LOCATE 23, 7: PRINT CHR$(25); " Y Neg             F4   Y+1";
LINE (3, 300)-(161, 366), 11, B 'Box for the scope move
LINE (163, 300)-(322, 366), 11, B 'Box for the image move
LOCATE 24, 2: PRINT "E/e Exposure Up/Dn";
LOCATE 25, 2: PRINT "Z/z Zero Up/Dn";
LOCATE 26, 2: PRINT "G/g Gain Up/Dn";
LOCATE 27, 2: PRINT "A/a Autozero";
LOCATE 28, 2: PRINT "F8 Calibrate";
LINE (3, 368)-(161, 448), 11, B
LOCATE 24, 22: PRINT "X/x X Cal Up/Dn";
LOCATE 25, 22: PRINT "Y/y Y Cal Up/Dn";
LOCATE 26, 22: PRINT "D/d DeadBand Up/Dn";
LOCATE 27, 22: PRINT "B/b Backlash Up/Dn";
LOCATE 28, 22: PRINT "W/w Delaytime Up/Dn";
LINE (163, 368)-(322, 448), 11, B
LOCATE 20, 42: PRINT "6/4 Pixel Depth    P/p Image On Toggle";
LOCATE 21, 42: PRINT "T/t Track Toggle   F/f Frame Sz Toggle";
LOCATE 22, 42: PRINT "O/o Circle Toggle  N/n Red Mode Toggle";
LOCATE 23, 42: PRINT "V/v Bin Toggle     Q/q Take Image";
LOCATE 24, 42: PRINT "L/l Thr Lvl Up/Dn  F9  Y Toggle  ";
LOCATE 25, 42: PRINT "H/h Help Screen    F10 Take Darkframe";
LOCATE 26, 42: PRINT "J/j Dark Fr Toggle K/k Fr Avg Toggle";
LOCATE 27, 42: PRINT "I/i Avg Trig Up/Dn M/m Avg Cnt Up/Dn";
LOCATE 28, 42: PRINT "U/u UART or LX-200 Esc Quit";

END SUB

SUB SerialWrite  '1 character at 300 BPS UART clock rate is 1/30 of a second
'motor on time.  This is async communications. .6 = clock ticks per 1/30
'second.

IF Lx <> 1 THEN                                 'external UART controller
        PRINT #1, STRING$(Nchr, CHR$(SData));
        PRINT #1, Null;
'        LOCATE 29, 44: PRINT Nchr; CHR$(SData + 48);
        Ticks = Nchr * .6066
        ClkTicks
ELSE
' At 9600 bps, 10 characters or 100 bits takes about .01 sec to complete
' One clock tick is about .06 seconds so forget about the xmit time
        savedata = SData
        IF SData = 1 THEN B$ = "#:Mw#"          'start W
        IF SData = 2 THEN B$ = "#:Me#"          'start E
        IF SData = 4 THEN B$ = "#:Ms#"          'start S
        IF SData = 8 THEN B$ = "#:Mn#"          'start N
        PRINT #1, "#:RC#";                      'Guide speed only!
        PRINT #1, B$;                           'Note ";" to suppress carriage return
        Ticks = Nchr * .6066                    'wait time still based on 1/30 sec.
        ClkTicks                                'wait
        IF SData = 1 THEN PRINT #1, "#:Qw#";    'stop W
        IF SData = 2 THEN PRINT #1, "#:Qe#";    'stop E
        IF SData = 4 THEN PRINT #1, "#:Qs#";    'stop S
        IF SData = 8 THEN PRINT #1, "#:Qn#";    'stop N  "
        Ticks = 1                               'wait one tick for motion to stop
        ClkTicks
END IF

END SUB

SUB SetPallete    'change the palette between white and red

Gamma = 1
FOR IP = 0 TO 15
  x = IP / 15
  Intens = 63 * (x ^ Gamma)
  PALETTE IP, 65536 * Intens + 256 * Intens + Intens
  IF RedSw = 1 THEN
    Intens = Intens * 31 / 47
    PALETTE IP, 65536 * 1 + 256 * 1 + Intens
  END IF
NEXT IP

END SUB

SUB WriteDark         'Write the darkframe to the disk

FOR iv = 1 TO SetNumV STEP DecmFact    'reads a frame
  FOR ih = 1 TO PixelsPerLine \ 2 STEP DecmFact    'Read a line
    IF BPPix <> 2 THEN
      Hi = lookup((Img1(iv, ih) AND &HF0) \ 16)
      Lo = lookup(Img1(iv, ih) AND &HF)
    ELSE
      ih3 = ih + (ih \ 2)
      IF ih MOD 2 = 1 THEN
        Hi = &H3F - (Img1(iv, ih3) \ 4)
        Lo = &H3F - (((Img1(iv, ih3) AND &H3) * 16) OR (Img1(iv, ih3 + 1) \ 16))
      ELSE
        Hi = &H3F - ((Img1(iv, ih3 - 1) AND &HF) * 4) OR (Img1(iv, ih3) \ 64)
        Lo = &H3F - (Img1(iv, ih3) AND &H3F)
      END IF
    END IF
    rec2 = rec2 + 1
    PUT #2, rec2, Hi
    rec2 = rec2 + 1
    PUT #2, rec2, Lo
  NEXT ih
NEXT iv

END SUB

SUB WriteFrame      'Write the data from the buffer to a .TGA file.
                    'Called by a "Q" key.
                    'First write a Targa header
iv = 0
PUT #3, , iv        'No Image Field ID
iv = &H3
PUT #3, , iv        'uncompressed Black and White image
iv = 0
PUT #3, , iv        'No color map spec for 5 bytes
PUT #3, , iv
PUT #3, , iv
rec2 = 9            'relocate the pointer - odd byte writes above
PUT #3, rec2, iv    'x origin
PUT #3, , iv        'y origin
PUT #3, , PixelsPerLine 'width of image in pixels low byte first
PUT #3, , SetNumV   'number of lines low byte first
iv = &H2008         'bits per pixel and image starts at top
PUT #3, , iv        'Field type image starts top left
rec2 = 18

FOR iv = 1 TO SetNumV STEP DecmFact
  FOR ih = 1 TO PixelsPerLine \ 2 STEP DecmFact
    IF BPPix <> 2 THEN
      Hi = lookup((Img1(iv, ih) AND &HF0) \ 16)
      Lo = lookup(Img1(iv, ih) AND &HF)
    ELSE
      ih3 = ih + (ih \ 2)
      IF ih MOD 2 = 1 THEN
        Hi = &H3F - (Img1(iv, ih3) \ 4)
        Lo = &H3F - (((Img1(iv, ih3) AND &H3) * 16) OR (Img1(iv, ih3 + 1) \ 16))
      ELSE
        Hi = &H3F - ((Img1(iv, ih3 - 1) AND &HF) * 4) OR (Img1(iv, ih3) \ 64)
        Lo = &H3F - (Img1(iv, ih3) AND &H3F)
      END IF
    END IF
    Hi = Hi + Lo * &H100    'do a int write rather than byte write.
    PUT #3, , Hi
  NEXT ih
NEXT iv

END SUB

